#include <stdio.h>


int main (int argc , char * argv[])
{
  FILE *ppmfile;
  
  int w, l;

  char c[80];

  int i, j;
  int comment;
  
  int R, G, B;
  int Y, Cr, Cb;
  int width = 320;
  int length = 240;

  if (argc != 2) {
    fprintf(stderr,"Usage: %s <filename>\n",argv[0]);
    return 1;
  } else {
    ppmfile = fopen(argv[1], "r");
  }

  if (!ppmfile) {
    fprintf(stderr,"Cannot find file.\n");
    return 1;
  }

  if (fscanf(ppmfile,"%s",c) != 1 || strcmp(c,"P3") != 0) {
      fprintf(stderr,"Unexpected file id of \"%s\", expected \"P3\"\n",c);
      return 1;
  }
  //  printf("Reading comments\n");
  /* ignore if comment */
  comment = 1;

  while (comment) {
    fscanf(ppmfile, "%s", c);
    if (c[0] == '#')
      fgets(c, 80, ppmfile);
    else {
      /* get width */
      w = atoi(c);
      comment = 0;
    }
  }
  //  printf("Width=%d\n", w);
  /* get length */
  fscanf(ppmfile, "%d", &l);
  //  printf("Length=%d\n", l);
  if (l != 480 || w != 512) {
    fprintf(stderr,"Not appropriate size image\n");
    return 1;
  }
  
  /* ignore next line, we know it's 8-bit */

  fscanf(ppmfile, "%d", &R);
  if (R != 255) {
    fprintf(stderr,"Format of ppm file not correct\n");
    return 1;
  }

  /* now, the delicious data */
  for (i = 0 ; i < l ; i++) {
    for (j = 0 ; j < w ; j++) {
      fscanf(ppmfile, "%d", &R);
      fscanf(ppmfile, "%d", &G);
      fscanf(ppmfile, "%d", &B);
   
      // Truncate image
      if ((i < length) && (j < width)) {
		printf("%x\n", R<<16 | G<<8 | B);
      }
    }
  }
  
  fclose(ppmfile);
  return 0;
}
