#include <stdio.h>

int main (int argc , char * argv[])
{
  FILE *rgbfile;
  FILE *ycrcbfile;

  int w, l;

  char c[128];

  int i, j, cnt;
  int comment;
  
  int R, G, B;
  unsigned int RGB;
  int Y, Cr, Cb;


  if (argc != 2) {
    fprintf(stderr,"Usage: %s <RGB_filename>\n",argv[0]);
    return 1;
  } else {
     rgbfile = fopen(argv[1], "r");
  }

  if (!rgbfile) {
    fprintf(stderr,"Cannot find file.\n");
    return 1;
  }

  /* assume length and width of output*/
  w = 512;
  l = 480;
  /* length and width of input */
  int width = 320;
  int length = 240;
  
  printf("P3\n");
  printf("# Created by Charles Giefer's program\n");
  printf("%d %d\n",w,l);
  printf("255");

  /* hack: read 3 comment lines */
  fgets(c, 128, rgbfile);
  fgets(c, 128, rgbfile);
  fgets(c, 128, rgbfile);
  
  /* now, the delicious data */
  for (i = 0 ; i < l ; i++) {
    for (j = 0 ; j < w ; j++) {
      if ((i < length) && (j < width)) {
		fscanf(rgbfile, "%x", &RGB);
      } else {
		RGB = 0x808080;
      }

      if (j%5 == 0) printf ("\n");
      
      R = (RGB & 0xff0000) >> 16;
      G = (RGB & 0x00ff00) >> 8;
      B = (RGB & 0x0000ff);

      printf("%3d %3d %3d ", R, G, B);
      
    }
  }
  
  fclose(rgbfile);
  return 0;
}
